/**   Thin Ice by Purobaz    **/

#include <fxlib.h>
#include "thinice.h"
#include "tileset.h"
#include "functions.h"
#include "MonochromeLib.h"

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	Tileset *menu = tileset_load(MENU);
	int key = 0, choice = 0, score;
	char c[6];
	
	while(1) {
		
		ML_clear_vram();
		ML_bmp_or(menu->tile[0], 0, 0, 128, 64);
		if(!choice) {
			ML_rectangle(34, 34, 101, 45, 1, ML_XOR, ML_XOR);
			ML_vertical_line(33, 35, 44, ML_BLACK);
			ML_vertical_line(102, 35, 44, ML_BLACK);
		}
		else {
			ML_rectangle(34, 49, 101, 60, 1, ML_XOR, ML_XOR);
			ML_vertical_line(33, 50, 59, ML_BLACK);
			ML_vertical_line(102, 50, 59, ML_BLACK);
			ML_horizontal_line(61, 66, 68, ML_BLACK);
			ML_pixel(67, 62, ML_BLACK);
			ML_horizontal_line(61, 75, 77, ML_BLACK);
			ML_pixel(76, 62, ML_BLACK);
			ML_horizontal_line(61, 82, 85, ML_BLACK);
			ML_horizontal_line(62, 83, 84, ML_BLACK);
			ML_horizontal_line(61, 97, 99, ML_BLACK);
			ML_pixel(98, 62, ML_BLACK);
		}
		ML_display_vram();
		
		GetKey(&key);
		if(key == KEY_CTRL_UP && choice) choice = 0;
		if(key == KEY_CTRL_DOWN && !choice) choice = 1;
		if(key == KEY_CTRL_EXE) {
			if(!choice) {
				ML_clear_vram();
				ML_bmp_or(menu->tile[0], 0, 0, 128, 64);
				ML_rectangle(32, 0, 103, 63, 1, ML_WHITE, ML_WHITE);
				PrintMini(45, 4, "Draw loops", 0);
				PrintMini(46, 12, "on the ice", 0);
				PrintMini(42, 20, "to cut holes.", 0);
				PrintMini(42, 32, "Try to drop", 0);
				PrintMini(41, 40, "the monsters", 0);
				PrintMini(40, 48, "in the water !", 0);
				ML_display_vram();
				
				key = 0;
				while(key != KEY_CTRL_EXE) GetKey(&key);
				
				score = engine();
				
				ML_clear_vram();
				ML_bmp_or(menu->tile[0], 0, 0, 128, 64);
				ML_rectangle(32, 0, 103, 63, 1, ML_WHITE, ML_WHITE);
				
				if(score < 0) {
					score = -score-1;
					PrintMini(52, 8, "Sorry,", 0);
					PrintMini(40, 16, "you drowned !", 0);
				}
				uintToChar(&c, score);
				PrintMini(38, 27, "You drowned", 0);
				PrintMini(90, 27, &c, 0);
				PrintMini(49, 35, "monsters", 0);
				ML_display_vram();
				
				key = 0;
				while(key != KEY_CTRL_EXE) GetKey(&key);
			}
			else {
				ML_clear_vram();
				ML_bmp_or(menu->tile[0], 0, 0, 128, 64);
				ML_rectangle(32, 0, 103, 63, 1, ML_WHITE, ML_WHITE);
				PrintXY(40, 3, "Thin Ice", 0);
				PrintMini(45, 14, "by Purobaz", 0);
				PrintMini(27, 22, "for the 48h CPC #14", 0);
				PrintMini(22, 30, "www.planet-casio.com", 0);
				PrintMini(44, 38, "inspired by", 0);
				PrintMini(28, 46, "the same game from", 0);
				PrintMini(34, 54, "www.nitrome.com", 0);
				ML_display_vram();
				
				key = 0;
				while(key != KEY_CTRL_EXE) GetKey(&key);
			}
		}
	}
	
    return 1;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum) {
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section